#include "test1.h"
#include "matrix1.h"
#include <iostream>

void printMatrix(const linalg::Matrix& matrix, const std::string& label) {
    std::cout << label << ":" << std::endl;
    std::cout << matrix;
}

void runMatrixGoodTests1() {
    std::cout << "Тест без ошибок";
    linalg::Matrix matrix(2, 3);
    std::cout << "Строки: " << matrix.rows() << ", Колонки: " << matrix.columns() << std::endl;
    std::cout << "Is empty: " << matrix.empty() << std::endl;

    matrix.reshape(3, 2);
    std::cout << "Reshaped: Строки: " << matrix.rows() << ", Колонки: " << matrix.columns() << std::endl;
}

void runMatrixBadTests1() {
    std::cout << "Тест с ошибками";
    linalg::Matrix matrix(-1, 2);
    std::cout << "Строки: " << matrix.rows() << ", Колонки: " << matrix.columns() << std::endl;
    std::cout << "Is empty: " << matrix.empty() << std::endl;

    matrix.reshape(3, 2);
    std::cout << "Reshaped: Строки: " << matrix.rows() << ", Колонки: " << matrix.columns() << std::endl;
}

void runMatrixGoodTests2() {
    std::cout << "Хороший тест\n";
    linalg::Matrix m0;
    std::cout << "Матрица m0: " <<  "Строки: " << m0.rows() << ", Колонки: " << m0.columns() << std::endl;
    linalg::Matrix m1(4);
    std::cout << "Матрица m1(4): " <<  "Строки: " << m1.rows() << ", Колонки: " << m1.columns() << std::endl;
    linalg::Matrix m2(4, 6);
    std::cout << "Матрица m2(4, 6): " <<  "Строки: " << m2.rows() << ", Колонки: " << m2.columns() << std::endl;
    linalg::Matrix m3(m1);
    std::cout << "Матрица m3(m1): " <<  "Строки: " << m3.rows() << ", Колонки: " << m3.columns() << std::endl;
    linalg::Matrix m4(std::move(m2));
    std::cout << "Матрица m4(std::move(m2)): " <<  "Строки: " << m4.rows() << ", Колонки: " << m4.columns() << std::endl;
    linalg::Matrix m5 = { {1, 2, 3}, {4, 5, 6} };
    std::cout << "Матрица m5 = { {1, 2, 3}, {4, 5, 6} }: " <<  "Строки: " << m5.rows() << ", Колонки: " << m5.columns() << std::endl;
    linalg::Matrix m6 = { {1, 2, 3, 4, 5, 6} };
    std::cout << "Матрица m6 = { {1, 2, 3, 4, 5, 6} }: " <<  "Строки: " << m6.rows() << ", Колонки: " << m6.columns() << std::endl;
    linalg::Matrix m7 = {1.0, 2.0, 3.0, 4.0, 5.0, 6.0};
    std::cout << "Матрица m7 = {1, 2, 3, 4, 5, 6}: " <<  "Строки: " << m7.rows() << ", Колонки: " << m7.columns() << std::endl;
    linalg::Matrix m8 = { {1}, {2}, {3}, {4}, {5}, {6} };
    std::cout << "Матрица m8 = { {1}, {2}, {3}, {4}, {5}, {6} }: " <<  "Строки: " << m8.rows() << ", Колонки: " << m8.columns() << std::endl;
}

void runMatrixBadTests2() {
    try {
        std::cout << "Плохой тест\n";
        std::cout << "Матрица m5 = { {1, 2, 3}, {4, 5, 6, 7} }: \n";
        linalg::Matrix m5 = {{1, 2, 3},
                             {4, 5, 6, 7}};
        std::cout << "Матрица m1(-4): \n";
        linalg::Matrix m1(-4);
        std::cout << "Матрица m2(-4, 3): \n";
        linalg::Matrix m2(-4, 3);

    } catch (const std::exception& e) {
        std::cerr << "Error: " << e.what() << std::endl;
    }
}

void runMatrixGoodTests4() {
    linalg::Matrix m0;
    linalg::Matrix m1(4);
    linalg::Matrix m2(4, 6);
    linalg::Matrix m3(m1);
    linalg::Matrix m4(std::move(m2));
    linalg::Matrix m5 = { {1, 2234252, 3244513225.1245123}, {4, 5, 6} };
    linalg::Matrix m6 = { {1, 2, 3, 4, 5, 6} };
    linalg::Matrix m7 = {1, 2, 3, 4, 5, 6};
    linalg::Matrix m8 = { {1}, {2}, {3}, {4}, {5}, {6} };
    std::cout << m0 << '\n' << m1 << '\n' << m2 << '\n' << m3 << '\n' << m4 << '\n' << m5 << '\n' << m6 << '\n' << m7 << '\n' << m8;
    std::cout << "Матрица до reshape:\n";
    std::cout << m5;
    std::cout << "Матрица после reshape:\n";
    m5.reshape(6, 1);
    std::cout << m5;
}

void runMatrixGoodTests3() {
    linalg::Matrix m1 = { {1.0, 2.0}, {3.0, 4.0} };

    linalg::Matrix m2 = {{1, 3}};
    std::cout << "Значение до приравнивания: \n" << m2;
    m2 = m1;
    std::cout << "Значение после приравнивания: \n" << m2;


    linalg::Matrix m3 = { {1.0, 2.0, 3.0}, {4.0, 5.0, 6.0} };
    double val = m3(0, 2); // Получить значение элемента
    std::cout << "m9(0, 2): " << val << std::endl;

    m3(0, 2) = 7.0; // Изменить значение элемента

    const linalg::Matrix c_m = { {1.0, 2.0, 3.0}, {4.0, 5.0, 6.0} };
    double val_c = c_m(0, 2); // Получить значение элемента из константной матрицы
    std::cout << "Значение из const matrix: " << val_c << std::endl;
    std::cout << "Попытка изменить элемент в константной матрице вызовет ошибку";
    // c_m(0, 2) = 7.0; // ОШИБКА
}


void test_operators() {
    linalg::Matrix m1 = { {1.0, 2.0}, {4.0, 5.0} };
    linalg::Matrix m2 = { {5.0, 6.0}, {7.0, 8.0} };
    double num = 3.0;

    printMatrix(m1, "Матрица 1");
    printMatrix(m2, "Матрица 2");
    std::cout << "Скаляр: " << num << std::endl;

    // Проверка оператора сложения (+)
    linalg::Matrix result = m1 + m2;
    printMatrix(result, "Результат сложения");

    // Проверка оператора сложения (+=)
    m1 += m2;
    printMatrix(m1, "Результат сложения (+=)");

    // Проверка оператора вычитания (-)
    linalg::Matrix result2 = m1 - m2;
    printMatrix(result2, "Результат вычитания");

    // Проверка оператора вычитания (-=)
    m1 -= m2;
    printMatrix(m1, "Результат вычитания (-=)");

    // Проверка оператора умножения (*)
    linalg::Matrix result3 = m1 * m2;
    printMatrix(result3, "Результат умножения");

    // Проверка оператора умножения на число (double * Matrix)
    linalg::Matrix result4 = num * m1;
    printMatrix(result4, "Результат умножения на скаляр");
    linalg::Matrix result5 = m1 * num;
    printMatrix(result5, "Результат умножения на скаляр (обратное)");

    // Проверка оператора умножения *=
    m1 *= m2;
    printMatrix(m1, "Результат умножения (*=) для матриц");
    // Проверка оператора умножения на число (Matrix *= double)
    m1 *= num;
    printMatrix(m1, "Результат умножения на скаляр (*=)");
    // Проверка оператора сравнения (==)
    bool isEqual = m1 == m2;
    std::cout << "Матрица 1 == Матрица 2: " << std::boolalpha << isEqual << std::endl;
    // Проверка оператора сравнения (!=)
    bool isNotEqual = m1 != m2;
    std::cout << "Матрица 1 != Матрица 2: " << std::boolalpha << isNotEqual << std::endl;
    linalg::Matrix m3 = { {1.0, 2.0}, {3.0, 4.0}, {5, 6} };
    std::cout << "Новую матрицу умножаем на другую и получаем ошибку\n" << m3;
    m1 *= m3;

}

void test_norm() {
    linalg::Matrix m1 = { {1.0, 2.0}, {3.0, 4.0} };
    printMatrix(m1, "m1");
    std::cout << m1.norm();
}

void test_trace() {
    linalg::Matrix m1 = { {1.0, 2.0}, {3.0, 4.0} };
    printMatrix(m1, "m1");
    std::cout << m1.trace();
}




